diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/mm/init.c ./arch/ppc/mm/init.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/mm/init.c	Wed May 12 09:56:50 1999
+++ ./arch/ppc/mm/init.c	Sun May 16 14:22:32 1999
@@ -50,10 +50,8 @@
 #include <asm/mbx.h>
 #include <asm/smp.h>
 #include <asm/bootx.h>
-/* APUS includes */
-#include <asm/setup.h>
-#include <asm/amigahw.h>
-/* END APUS includes */
+#include <asm/setup.h>		/* struct mem_info */
+#include <asm/amigahw.h>	/* zTwoBase */
 
 int prom_trashed;
 atomic_t next_mmu_context;
@@ -65,18 +63,19 @@
 extern char __init_begin, __init_end;
 extern char __prep_begin, __prep_end;
 extern char __pmac_begin, __pmac_end;
+extern char __apus_begin, __apus_end;
 extern char __openfirmware_begin, __openfirmware_end;
 char *klimit = _end;
 struct device_node *memory_node;
 unsigned long ioremap_base;
 unsigned long ioremap_bot;
 unsigned long avail_start;
-extern int num_memory;
-extern struct mem_info memory[NUM_MEMINFO];
-extern boot_infos_t *boot_infos;
 #ifndef __SMP__
 struct pgtable_cache_struct quicklists;
 #endif
+extern int num_memory;
+extern struct mem_info memory[];
+extern boot_infos_t *boot_infos;
 
 void MMU_init(void);
 static void *MMU_get_page(void);
@@ -388,6 +387,23 @@
 			v = (ioremap_bot -= size);
 	}
 
+#if 1
+	/* FIXME: Temporary hack to allow ptov conversions. */
+	{
+		extern unsigned long kmap_chunks[];
+		extern int kmap_chunk_count;
+
+		kmap_chunks[kmap_chunk_count++] = p;
+		kmap_chunks[kmap_chunk_count++] = size;
+		kmap_chunks[kmap_chunk_count++] = v;
+
+#if 0
+		printk ("ioremap: %08lx (%08lx) -> %08lx\n",
+			p, size, v);
+#endif
+	}
+#endif
+
 	if ((flags & _PAGE_PRESENT) == 0)
 		flags |= pgprot_val(PAGE_KERNEL);
 	if (flags & (_PAGE_NO_CACHE | _PAGE_WRITETHRU))
@@ -425,13 +441,7 @@
 	/* Check the BATs */
 	for (b = 0; b < 4; ++b)
 		if (addr >= bat_addrs[b].start && addr <= bat_addrs[b].limit)
-#ifndef CONFIG_APUS
-			return bat_addrs[b].phys | idx;
-#else
-			/* Do a more precise remapping of virtual address */
-			/* --Carsten */
 			return (bat_addrs[b].phys - bat_addrs[b].start + addr) | idx;
-#endif /* CONFIG_APUS */
 #endif /* CONFIG_8xx */
 	/* Do we have a page table? */
 	if (init_task.mm->pgd == NULL)
@@ -961,7 +971,8 @@
 {
 	unsigned long a;
 	unsigned long num_freed_pages = 0, num_prep_pages = 0,
-		num_pmac_pages = 0, num_openfirmware_pages = 0;
+		num_pmac_pages = 0, num_openfirmware_pages = 0,
+		num_apus_pages = 0;
 #define FREESEC(START,END,CNT) do { \
 	a = (unsigned long)(&START); \
 	for (; a < (unsigned long)(&END); a += PAGE_SIZE) { \
@@ -976,25 +987,33 @@
 	switch (_machine)
 	{
 	case _MACH_Pmac:
+		FREESEC(__apus_begin,__apus_end,num_apus_pages);
 		FREESEC(__prep_begin,__prep_end,num_prep_pages);
 		break;
 	case _MACH_chrp:
+		FREESEC(__apus_begin,__apus_end,num_apus_pages);
 		FREESEC(__pmac_begin,__pmac_end,num_pmac_pages);
 		FREESEC(__prep_begin,__prep_end,num_prep_pages);
 		break;
 	case _MACH_prep:
+		FREESEC(__apus_begin,__apus_end,num_apus_pages);
 		FREESEC(__pmac_begin,__pmac_end,num_pmac_pages);
 		break;
 	case _MACH_mbx:
+		FREESEC(__apus_begin,__apus_end,num_apus_pages);
+		FREESEC(__pmac_begin,__pmac_end,num_pmac_pages);
+		FREESEC(__prep_begin,__prep_end,num_prep_pages);
+		break;
+	case _MACH_apus:
 		FREESEC(__pmac_begin,__pmac_end,num_pmac_pages);
 		FREESEC(__prep_begin,__prep_end,num_prep_pages);
 		break;
 	}
-
+	
 	if ( !have_of )
 		FREESEC( __openfirmware_begin, __openfirmware_end,
 			 num_openfirmware_pages );
-	
+
 	printk ("Freeing unused kernel memory: %ldk init",
 		(num_freed_pages * PAGE_SIZE) >> 10);
 	if ( num_prep_pages )
@@ -1003,6 +1022,8 @@
 		printk(" %ldk pmac",(num_pmac_pages*PAGE_SIZE)>>10);
 	if ( num_openfirmware_pages )
 		printk(" %ldk open firmware",(num_openfirmware_pages*PAGE_SIZE)>>10);
+	if ( num_apus_pages )
+		printk(" %ldk apus",(num_apus_pages*PAGE_SIZE)>>10);
 	printk("\n");
 }
 
@@ -1067,9 +1089,6 @@
 		setbat(0, 0xfff00000, 0xfff00000, 0x00020000, RAM_PAGE);
 		/* Map chip and ZorroII memory */
 		setbat(1, zTwoBase,   0x00000000, 0x01000000, IO_PAGE);
-		/* Note: a temporary hack in arch/ppc/amiga/setup.c
-		   (kernel_map) remaps individual IO regions to
-		   0x90000000. */
 		break;
 	}
 	ioremap_bot = ioremap_base;
@@ -1412,7 +1431,6 @@
 	return (__va(total));
 }
 
-#ifdef CONFIG_APUS
 #define HARDWARE_MAPPED_SIZE (512*1024)
 __initfunc(unsigned long *apus_find_end_of_memory(void))
 {
@@ -1487,7 +1505,6 @@
 	   using the z2ram device. */
 	return __va(memory[0].addr + memory[0].size);
 }
-#endif /* CONFIG_APUS */
 
 /*
  * Initialize the hash table and patch the instructions in head.S.
@@ -1543,11 +1560,6 @@
 	       ramsize >> 20, Hash_size >> 10, Hash);
 	if ( Hash_size )
 	{
-#ifdef CONFIG_APUS
-#define b(x) ((unsigned int*)(((unsigned long)(x)) - KERNELBASE + 0xfff00000))
-#else
-#define b(x) (x)
-#endif
 		/*memset(Hash, 0, Hash_size);*/
 		__clear_user(Hash, Hash_size);
 		
@@ -1557,20 +1569,20 @@
 		 * Patch up the instructions in head.S:hash_page
 		 */
 		Hash_bits = ffz(~Hash_size) - 6;
-		*b(hash_page_patch_A) = (*b(hash_page_patch_A) & ~0xffff)
+		hash_page_patch_A[0] = (hash_page_patch_A[0] & ~0xffff)
 			| (__pa(Hash) >> 16);
-		*b(hash_page_patch_A + 1) = (*b(hash_page_patch_A + 1)& ~0x7c0)
+		hash_page_patch_A[1] = (hash_page_patch_A[1] & ~0x7c0)
 			| ((26 - Hash_bits) << 6);
 		if (Hash_bits > 16)
 			Hash_bits = 16;
-		*b(hash_page_patch_A + 2) = (*b(hash_page_patch_A + 2)& ~0x7c0)
+		hash_page_patch_A[2] = (hash_page_patch_A[2] & ~0x7c0)
 			| ((26 - Hash_bits) << 6);
-		*b(hash_page_patch_B) = (*b(hash_page_patch_B) & ~0xffff)
+		hash_page_patch_B[0] = (hash_page_patch_B[0] & ~0xffff)
 			| (Hash_mask >> 10);
-		*b(hash_page_patch_C) = (*b(hash_page_patch_C) & ~0xffff)
+		hash_page_patch_C[0] = (hash_page_patch_C[0] & ~0xffff)
 			| (Hash_mask >> 10);
 #if 0	/* see hash_page in head.S, note also patch_C ref below */
-		*b(hash_page_patch_D) = (*b(hash_page_patch_D) & ~0xffff)
+		hash_page_patch_D[0] = (hash_page_patch_D[0] & ~0xffff)
 			| (Hash_mask >> 10);
 #endif
 		/*
@@ -1578,8 +1590,8 @@
 		 * out from the data cache and invalidated in the instruction
 		 * cache, on those machines with split caches.
 		 */
-		flush_icache_range((unsigned long) b(hash_page_patch_A),
-				   (unsigned long) b(hash_page_patch_C + 1));
+		flush_icache_range((unsigned long) &hash_page_patch_A[0],
+				   (unsigned long) &hash_page_patch_C[1]);
 	}
 	else {
 		Hash_end = 0;
@@ -1588,9 +1600,9 @@
 		 * start of hash_page, since we can still get DSI
 		 * exceptions on a 603.
 		 */
-		*b(hash_page) = 0x4e800020;
-		flush_icache_range((unsigned long) b(hash_page),
-				   (unsigned long) b(hash_page + 1));
+		hash_page[0] = 0x4e800020;
+		flush_icache_range((unsigned long) &hash_page[0],
+				   (unsigned long) &hash_page[1]);
 	}
 }
 #endif /* ndef CONFIG_8xx */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/vmlinux.lds ./arch/ppc/vmlinux.lds
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/vmlinux.lds	Mon Jan  4 15:15:08 1999
+++ ./arch/ppc/vmlinux.lds	Mon Jan 11 22:56:56 1999
@@ -70,7 +70,15 @@
   . = ALIGN(4096);
   __init_begin = .;
   .text.init : { *(.text.init) }
-  .data.init : { *(.data.init) }
+  .data.init : { 
+    *(.data.init);
+    __vtop_table_begin = .;
+    *(.vtop_fixup);
+    __vtop_table_end = .;
+    __ptov_table_begin = .;
+    *(.ptov_fixup);
+    __ptov_table_end = .;
+  }
   . = ALIGN(4096);
   __init_end = .;
 
@@ -87,6 +95,13 @@
   .data.prep : { *(.data.prep) }
   . = ALIGN(4096);
   __prep_end = .;
+
+  . = ALIGN(4096);
+  __apus_begin = .;
+  .text.apus : { *(.text.apus) }
+  .data.apus : { *(.data.apus) }
+  . = ALIGN(4096);
+  __apus_end = .;
 
   . = ALIGN(4096);
   __openfirmware_begin = .;
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/char/Makefile ./drivers/char/Makefile
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/char/Makefile	Tue May 11 11:26:42 1999
+++ ./drivers/char/Makefile	Sat May 15 18:55:43 1999
@@ -196,9 +196,11 @@
 L_OBJS += defkeymap.o
 endif
 
+ifndef CONFIG_APUS
 ifneq ($(ARCH),m68k)
 L_OBJS += pc_keyb.o
 endif
+endif
 
 ifdef CONFIG_Q40
 L_OBJS += q40_keyb.o
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/char/lp_m68k.c ./drivers/char/lp_m68k.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/char/lp_m68k.c	Tue Jan 19 11:56:05 1999
+++ ./drivers/char/lp_m68k.c	Fri Feb  5 20:42:53 1999
@@ -45,6 +45,10 @@
 #include <linux/init.h>
 #include <linux/kmod.h>
 
+#ifdef CONFIG_APUS
+#define m68k_debug_device debug_device
+#endif
+
 #ifdef CONFIG_AMIGA
 #ifdef CONFIG_MULTIFACE_III_LP
 #include <linux/lp_mfc.h>
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/char/ser_ioext.c ./drivers/char/ser_ioext.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/char/ser_ioext.c	Fri Apr 23 17:27:53 1999
+++ ./drivers/char/ser_ioext.c	Sat May 15 11:35:25 1999
@@ -776,6 +776,7 @@
 {
     /* Wait for the uart to get empty */
     while (!(uart->LSR & TEMT)) {
+	    mb();
 #if IOEXT_DEBUG
 	printk("Waiting for transmitter to finish\n");
 #endif
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/net/8390.c ./drivers/net/8390.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/net/8390.c	Tue May 11 11:26:58 1999
+++ ./drivers/net/8390.c	Sun May 16 10:39:37 1999
@@ -256,8 +256,12 @@
 		spin_unlock_irqrestore(&ei_local->page_lock, flags);
 
 		/* Ugly but a reset can be slow, yet must be protected */
-		
+#if	0 /* FIXME:APUS: */
 		disable_irq_nosync(dev->irq);
+#else
+		disable_irq(dev->irq);
+		synchronize_irq();
+#endif
 		spin_lock(&ei_local->page_lock);
 		
 		/* Try to restart the card.  Perhaps the user has fixed something. */
@@ -285,7 +289,12 @@
 	 *	Slow phase with lock held.
 	 */
 	 
-	disable_irq_nosync(dev->irq);
+#if	0 /* FIXME:APUS: */
+		disable_irq_nosync(dev->irq);
+#else
+		disable_irq(dev->irq);
+		synchronize_irq();
+#endif
 	
 	spin_lock(&ei_local->page_lock);
 	
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/net/Config.in ./drivers/net/Config.in
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/net/Config.in	Wed Mar 24 11:31:05 1999
+++ ./drivers/net/Config.in	Sat May 15 11:35:29 1999
@@ -41,6 +41,9 @@
     tristate 'A2065 support' CONFIG_A2065
     tristate 'Hydra support' CONFIG_HYDRA
   fi
+  if [ "$CONFIG_AMIGA_PCMCIA" = "y" ]; then
+    tristate 'PCMCIA NE2000 support' CONFIG_APNE
+  fi
   if [ "$CONFIG_MIPS_JAZZ" = "y" ]; then
     bool 'MIPS JAZZ onboard SONIC Ethernet support' CONFIG_MIPS_JAZZ_SONIC
   fi
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/net/slhc.c ./drivers/net/slhc.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/net/slhc.c	Mon Jan  4 11:30:51 1999
+++ ./drivers/net/slhc.c	Sun May 16 20:55:44 1999
@@ -518,7 +518,7 @@
 		x = *cp++;	/* Read conn index */
 		if(x < 0 || x > comp->rslot_limit)
 			goto bad;
-
+		if (comp->rstate[x].cs_hsize==0) goto bad;    /* header lost */
 		comp->flags &=~ SLF_TOSS;
 		comp->recv_current = x;
 	} else {
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/Config.in ./drivers/scsi/Config.in
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/Config.in	Tue May 11 11:27:19 1999
+++ ./drivers/scsi/Config.in	Sat May 15 11:35:36 1999
@@ -18,6 +18,73 @@
 mainmenu_option next_comment
 comment 'SCSI low-level drivers'
 
+# Default is to ask for all drivers. This may be disabled in the below
+# code handling specific platforms.
+define_bool CONFIG_SCSI_ALL y
+
+if [ "$CONFIG_AMIGA" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  dep_tristate 'A3000 WD33C93A support' CONFIG_A3000_SCSI $CONFIG_SCSI
+  if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+    bool 'A4000T SCSI support' CONFIG_A4000T_SCSI
+  fi
+fi
+if [ "$CONFIG_ZORRO" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  dep_tristate 'A2091 WD33C93A support' CONFIG_A2091_SCSI $CONFIG_SCSI
+  dep_tristate 'GVP Series II WD33C93A support' CONFIG_GVP11_SCSI $CONFIG_SCSI
+  dep_tristate 'CyberStorm SCSI support' CONFIG_CYBERSTORM_SCSI $CONFIG_SCSI
+  dep_tristate 'CyberStorm Mk II SCSI support' CONFIG_CYBERSTORMII_SCSI $CONFIG_SCSI
+  dep_tristate 'Blizzard 2060 SCSI support' CONFIG_BLZ2060_SCSI $CONFIG_SCSI
+  dep_tristate 'Blizzard 1230IV/1260 SCSI support' CONFIG_BLZ1230_SCSI $CONFIG_SCSI
+  dep_tristate 'Fastlane SCSI support' CONFIG_FASTLANE_SCSI $CONFIG_SCSI
+  if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+    bool 'A4091 SCSI support' CONFIG_A4091_SCSI
+    bool 'WarpEngine SCSI support' CONFIG_WARPENGINE_SCSI
+    bool 'Blizzard PowerUP 603e+ SCSI' CONFIG_BLZ603EPLUS_SCSI
+    dep_tristate 'BSC Oktagon SCSI support' CONFIG_OKTAGON_SCSI $CONFIG_SCSI
+#    bool 'Cyberstorm Mk III SCSI support' CONFIG_CYBERSTORMIII_SCSI
+#    bool 'GVP Turbo 040/060 SCSI support' CONFIG_GVP_TURBO_SCSI
+  fi
+fi
+
+if [ "$CONFIG_ATARI" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  dep_tristate 'Atari native SCSI support' CONFIG_ATARI_SCSI $CONFIG_SCSI
+  if [ "$CONFIG_ATARI_SCSI" != "n" ]; then
+    bool '  Long delays for Toshiba CD-ROMs' CONFIG_ATARI_SCSI_TOSHIBA_DELAY
+    bool '  Reset SCSI-devices at boottime' CONFIG_ATARI_SCSI_RESET_BOOT
+    if [ "$CONFIG_EXPERIMENTAL" = "y" -a "$CONFIG_HADES" = "y" ]; then
+      bool '  Hades SCSI DMA emulator (EXPERIMENTAL)' CONFIG_TT_DMA_EMUL
+    fi
+  fi
+fi
+
+if [ "$CONFIG_MAC" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  bool 'MAC NCR5380 SCSI' CONFIG_MAC_SCSI
+  dep_tristate 'MAC NCR53c9[46] SCSI' CONFIG_SCSI_MAC_ESP $CONFIG_SCSI
+fi
+
+if [ "$CONFIG_VME" = "y" -a "$CONFIG_MVME16x" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  bool 'NCR53C710 SCSI driver for MVME16x' CONFIG_MVME16x_SCSI
+fi
+
+if [ "$CONFIG_VME" = "y" -a "$CONFIG_BVME6000" = "y" ]; then
+  define_bool CONFIG_SCSI_ALL n
+
+  bool 'NCR53C710 SCSI driver for BVME6000' CONFIG_BVME6000_SCSI
+fi
+
+# Generic SCSI
+if [ "CONFIG_SCSI_ALL" = "y" ];then
+
 dep_tristate '7000FASST SCSI support' CONFIG_SCSI_7000FASST $CONFIG_SCSI
 dep_tristate 'ACARD SCSI support' CONFIG_SCSI_ACARD $CONFIG_SCSI
 dep_tristate 'Adaptec AHA152X/2825 support' CONFIG_SCSI_AHA152X $CONFIG_SCSI
@@ -140,6 +207,7 @@
     int  '  maximum number of queued commands' CONFIG_SCSI_U14_34F_MAX_TAGS 8
   fi
 dep_tristate 'UltraStor SCSI support' CONFIG_SCSI_ULTRASTOR $CONFIG_SCSI
+fi # CONFIG_SCSI_ALL
 #
 # Note - this is a very special 'host' adapter that simulates the presence of some disks.
 # It can come in very handy for troubleshooting.  Anyone else is welcome to use it - all
@@ -151,7 +219,7 @@
 if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
   dep_tristate 'SCSI debugging host adapter' CONFIG_SCSI_DEBUG $CONFIG_SCSI
 fi
-if [ "$CONFIG_PPC" = "y" ]; then
+if [ "$CONFIG_PMAC" = "y" ]; then
   dep_tristate 'MESH (Power Mac internal SCSI) support' CONFIG_SCSI_MESH $CONFIG_SCSI
   if [ "$CONFIG_SCSI_MESH" != "n" ]; then
     int '  maximum synchronous transfer rate (MB/s) (0 = async)' CONFIG_SCSI_MESH_SYNC_RATE 5
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/a2091.c ./drivers/scsi/a2091.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/a2091.c	Tue May 11 11:02:46 1999
+++ ./drivers/scsi/a2091.c	Sun May 16 20:49:27 1999
@@ -53,6 +53,7 @@
     unsigned short cntr = CNTR_PDMD | CNTR_INTEN;
     unsigned long addr = virt_to_bus(cmd->SCp.ptr);
     struct Scsi_Host *instance = cmd->host;
+    static int scsi_alloc_out_of_range = 0;
 
     /* don't allow DMA if the physical address is bad */
     if (addr & A2091_XFER_MASK ||
@@ -60,41 +61,55 @@
     {
 	HDATA(instance)->dma_bounce_len = (cmd->SCp.this_residual + 511)
 	    & ~0x1ff;
-	HDATA(instance)->dma_bounce_buffer =
-	    scsi_malloc (HDATA(instance)->dma_bounce_len);
-	
-	/* can't allocate memory; use PIO */
-	if (!HDATA(instance)->dma_bounce_buffer) {
-	    HDATA(instance)->dma_bounce_len = 0;
-	    return 1;
+ 	if( !scsi_alloc_out_of_range ) {
+	    HDATA(cmd->host)->dma_bounce_buffer =
+		scsi_malloc (HDATA(cmd->host)->dma_bounce_len);
+	    HDATA(cmd->host)->dma_buffer_pool = BUF_SCSI_ALLOCED;
 	}
 
-	/* get the physical address of the bounce buffer */
-	addr = virt_to_bus(HDATA(instance)->dma_bounce_buffer);
+	if ( scsi_alloc_out_of_range || !HDATA(cmd->host)->dma_bounce_buffer) {
+	    HDATA(cmd->host)->dma_bounce_buffer =
+		amiga_chip_alloc(HDATA(cmd->host)->dma_bounce_len);
+
+	    if(!HDATA(cmd->host)->dma_bounce_buffer)
+	    {
+		HDATA(cmd->host)->dma_bounce_len = 0;
+		return 1;
+	    }
 
-	/* the bounce buffer may not be in the first 16M of physmem */
-	if (addr & A2091_XFER_MASK) {
-	    /* we could use chipmem... maybe later */
-	    scsi_free (HDATA(instance)->dma_bounce_buffer,
-		       HDATA(instance)->dma_bounce_len);
-	    HDATA(instance)->dma_bounce_buffer = NULL;
-	    HDATA(instance)->dma_bounce_len = 0;
-	    return 1;
+	    HDATA(cmd->host)->dma_buffer_pool = BUF_CHIP_ALLOCED;
 	}
 
+	/* check if the address of the bounce buffer is OK */
+	addr = virt_to_bus(HDATA(cmd->host)->dma_bounce_buffer);
+
+	if (addr & A2091_XFER_MASK) {
+	    /* fall back to Chip RAM if address out of range */
+	    if( HDATA(cmd->host)->dma_buffer_pool == BUF_SCSI_ALLOCED) {
+		scsi_free (HDATA(cmd->host)->dma_bounce_buffer,
+			   HDATA(cmd->host)->dma_bounce_len);
+		scsi_alloc_out_of_range = 1;
+	    } else {
+		amiga_chip_free (HDATA(cmd->host)->dma_bounce_buffer);
+            }
+		
+	    HDATA(cmd->host)->dma_bounce_buffer =
+		amiga_chip_alloc(HDATA(cmd->host)->dma_bounce_len);
+
+	    if(!HDATA(cmd->host)->dma_bounce_buffer)
+	    {
+		HDATA(cmd->host)->dma_bounce_len = 0;
+		return 1;
+	    }
+
+	    addr = virt_to_bus(HDATA(cmd->host)->dma_bounce_buffer);
+	    HDATA(cmd->host)->dma_buffer_pool = BUF_CHIP_ALLOCED;
+	}
+	    
 	if (!dir_in) {
 	    /* copy to bounce buffer for a write */
-	    if (cmd->use_sg)
-#if 0
-		panic ("scsi%ddma: incomplete s/g support",
-		       instance->host_no);
-#else
-		memcpy (HDATA(instance)->dma_bounce_buffer,
-			cmd->SCp.ptr, cmd->SCp.this_residual);
-#endif
-	    else
-		memcpy (HDATA(instance)->dma_bounce_buffer,
-			cmd->request_buffer, cmd->request_bufflen);
+	    memcpy (HDATA(cmd->host)->dma_bounce_buffer,
+		    cmd->SCp.ptr, cmd->SCp.this_residual);
 	}
     }
 
@@ -118,7 +133,9 @@
 	cache_push (addr, cmd->SCp.this_residual);
       }
     /* start DMA */
+    mb();			/* make sure setup is completed */
     DMA(cmd->host)->ST_DMA = 1;
+    mb();			/* make sure DMA has started before next IO */
 
     /* return success */
     return 0;
@@ -135,12 +152,15 @@
 
     /* disable SCSI interrupts */
     DMA(instance)->CNTR = cntr;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* flush if we were reading */
     if (HDATA(instance)->dma_dir) {
 	DMA(instance)->FLUSH = 1;
+	mb();			/* don't allow prefetch */
 	while (!(DMA(instance)->ISTR & ISTR_FE_FLG))
-	    ;
+	    barrier();
+	mb();			/* no IO until FLUSH is done */
     }
 
     /* clear a possible interrupt */
@@ -148,38 +168,27 @@
 
     /* stop DMA */
     DMA(instance)->SP_DMA = 1;
+    mb();			/* make sure DMA is stopped before next IO */
 
     /* restore the CONTROL bits (minus the direction flag) */
     DMA(instance)->CNTR = CNTR_PDMD | CNTR_INTEN;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* copy from a bounce buffer, if necessary */
     if (status && HDATA(instance)->dma_bounce_buffer) {
-	if (SCpnt && SCpnt->use_sg) {
-#if 0
-	    panic ("scsi%d: incomplete s/g support",
-		   instance->host_no);
-#else
-	    if( HDATA(instance)->dma_dir )
-		memcpy (SCpnt->SCp.ptr, 
-			HDATA(instance)->dma_bounce_buffer,
-			SCpnt->SCp.this_residual);
-	    scsi_free (HDATA(instance)->dma_bounce_buffer,
-		       HDATA(instance)->dma_bounce_len);
-	    HDATA(instance)->dma_bounce_buffer = NULL;
-	    HDATA(instance)->dma_bounce_len = 0;
-	    
-#endif
-	} else {
-	    if (HDATA(instance)->dma_dir && SCpnt)
-		memcpy (SCpnt->request_buffer,
-			HDATA(instance)->dma_bounce_buffer,
-			SCpnt->request_bufflen);
-
+	if (HDATA(instance)->dma_dir && SCpnt)
+	    memcpy (SCpnt->SCp.ptr, 
+		    HDATA(instance)->dma_bounce_buffer,
+		    SCpnt->SCp.this_residual);
+	
+	if (HDATA(instance)->dma_buffer_pool == BUF_SCSI_ALLOCED)
 	    scsi_free (HDATA(instance)->dma_bounce_buffer,
 		       HDATA(instance)->dma_bounce_len);
-	    HDATA(instance)->dma_bounce_buffer = NULL;
-	    HDATA(instance)->dma_bounce_len = 0;
-	}
+	else
+	    amiga_chip_free(HDATA(instance)->dma_bounce_buffer);
+	
+	HDATA(instance)->dma_bounce_buffer = NULL;
+	HDATA(instance)->dma_bounce_len = 0;
     }
 }
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/a3000.c ./drivers/scsi/a3000.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/a3000.c	Tue Sep  1 18:56:07 1998
+++ ./drivers/scsi/a3000.c	Tue Mar 23 21:32:27 1999
@@ -32,7 +32,7 @@
 
 static void a3000_intr (int irq, void *dummy, struct pt_regs *fp)
 {
-    unsigned int status = DMA(a3000_host)->ISTR;
+    unsigned short status = DMA(a3000_host)->ISTR;
 
     if (!(status & ISTR_INT_P))
 	return;
@@ -102,7 +102,9 @@
 	cache_push (addr, cmd->SCp.this_residual);
 
     /* start DMA */
+    mb();			/* make sure setup is completed */
     DMA(a3000_host)->ST_DMA = 1;
+    mb();			/* make sure DMA has started before next IO */
 
     /* return success */
     return 0;
@@ -118,12 +120,15 @@
 	cntr |= CNTR_DDIR;
 
     DMA(instance)->CNTR = cntr;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* flush if we were reading */
     if (HDATA(instance)->dma_dir) {
 	DMA(instance)->FLUSH = 1;
+	mb();			/* don't allow prefetch */
 	while (!(DMA(instance)->ISTR & ISTR_FE_FLG))
-	    ;
+	    barrier();
+	mb();			/* no IO until FLUSH is done */
     }
 
     /* clear a possible interrupt */
@@ -134,9 +139,11 @@
 
     /* stop DMA */
     DMA(instance)->SP_DMA = 1;
+    mb();			/* make sure DMA is stopped before next IO */
 
     /* restore the CONTROL bits (minus the direction flag) */
     DMA(instance)->CNTR = CNTR_PDMD | CNTR_INTEN;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* copy from a bounce buffer, if necessary */
     if (status && HDATA(instance)->dma_bounce_buffer) {
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/gvp11.c ./drivers/scsi/gvp11.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/gvp11.c	Wed May 12 10:03:07 1999
+++ ./drivers/scsi/gvp11.c	Sat May 15 11:35:36 1999
@@ -127,6 +127,7 @@
 
     HDATA(cmd->host)->dma_dir = dir_in;
     DMA(cmd->host)->CNTR = cntr;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* setup DMA *physical* address */
     DMA(cmd->host)->ACR = addr;
@@ -142,7 +143,9 @@
 	    DMA(cmd->host)->BANK = bank_mask & (addr >> 18);
 
     /* start DMA */
+    mb();			/* make sure setup is completed */
     DMA(cmd->host)->ST_DMA = 1;
+    mb();			/* make sure DMA has started before next IO */
 
     /* return success */
     return 0;
@@ -155,6 +158,7 @@
     DMA(instance)->SP_DMA = 1;
     /* remove write bit from CONTROL bits */
     DMA(instance)->CNTR = GVP11_DMAC_INT_ENABLE;
+    mb();			/* make sure CNTR is updated before next IO */
 
     /* copy from a bounce buffer, if necessary */
     if (status && HDATA(instance)->dma_bounce_buffer) {
@@ -316,9 +320,14 @@
 
 
 	DMA(instance)->secret2 = 1;
+	mb();			/* ensure IO order */
 	DMA(instance)->secret1 = 0;
+	mb();			/* ensure IO order */
 	DMA(instance)->secret3 = 15;
-	while (DMA(instance)->CNTR & GVP11_DMAC_BUSY) ;
+	mb();			/* ensure IO order */
+	while (DMA(instance)->CNTR & GVP11_DMAC_BUSY)
+		barrier();
+	mb();			/* ensure IO order */
 	DMA(instance)->CNTR = 0;
 
 	DMA(instance)->BANK = 0;
@@ -341,6 +350,7 @@
 		request_irq(IRQ_AMIGA_PORTS, gvp11_intr, 0,
 			    "GVP11 SCSI", gvp11_intr);
 	}
+	mb();			/* ensure IO order */
 	DMA(instance)->CNTR = GVP11_DMAC_INT_ENABLE;
 	zorro_config_board(key, 0);
     }
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/sd.c ./drivers/scsi/sd.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/scsi/sd.c	Tue May 11 11:27:33 1999
+++ ./drivers/scsi/sd.c	Sat May 15 11:35:38 1999
@@ -68,13 +68,13 @@
 #define N_USED_SCSI_DISKS  (sd_template.dev_max + SCSI_DISKS_PER_MAJOR - 1)
 #define N_USED_SD_MAJORS   (N_USED_SCSI_DISKS / SCSI_DISKS_PER_MAJOR)
 
-#define MAX_RETRIES 5
+#define MAX_RETRIES 100
 
 /*
  *  Time out in seconds for disks and Magneto-opticals (which are slower).
  */
 
-#define SD_TIMEOUT (15 * HZ)
+#define SD_TIMEOUT (50 * HZ)
 #define SD_MOD_TIMEOUT (75 * HZ)
 
 #define CLUSTERABLE_DEVICE(SC) (SC->host->use_clustering && \
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/drivers/sound/dmasound.c ./drivers/sound/dmasound.c
--- /home/jskov/kernel/dist/linux-2.2.8/drivers/sound/dmasound.c	Fri Mar 26 11:54:46 1999
+++ ./drivers/sound/dmasound.c	Sat May 15 11:35:41 1999
@@ -107,7 +107,7 @@
 #include <asm/amigahw.h>
 #include <asm/amigaints.h>
 #endif /* CONFIG_AMIGA */
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 #include <asm/prom.h>
 #include <asm/io.h>
 #include <asm/dbdma.h>
@@ -117,7 +117,7 @@
 #include "awacs_defs.h"
 #include <linux/nvram.h>
 #include <linux/vt_kern.h>
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 #include "dmasound.h"
 #include <linux/soundcard.h>
@@ -164,7 +164,7 @@
 
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 /*
  * Interrupt numbers and addresses, obtained from the device tree.
  */
@@ -261,7 +261,7 @@
 };
 #endif /* CONFIG_PMAC_PBOOK */
 
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 /*** Some declarations *******************************************************/
 
@@ -599,7 +599,7 @@
 			    ssize_t frameLeft);
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 static ssize_t pmac_ct_law(const u_char *userPtr, size_t userCount,
 			   u_char frame[], ssize_t *frameUsed,
 			   ssize_t frameLeft);
@@ -630,7 +630,7 @@
 static ssize_t pmac_ctx_u16(const u_char *userPtr, size_t userCount,
 			    u_char frame[], ssize_t *frameUsed,
 			    ssize_t frameLeft);
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 /*** Machine definitions *****************************************************/
 
@@ -687,7 +687,7 @@
 	int treble;
 	int gain;
 	int minDev;		/* minor device number currently open */
-#if defined(CONFIG_ATARI) || defined(CONFIG_PPC)
+#if defined(CONFIG_ATARI) || defined(CONFIG_PMAC)
 	int bal;		/* balance factor for expanding (not volume!) */
 	u_long data;		/* data for expanding */
 #endif /* CONFIG_ATARI */
@@ -736,7 +736,7 @@
 static void ami_sq_interrupt(int irq, void *dummy, struct pt_regs *fp);
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 static void *PMacAlloc(unsigned int size, int flags);
 static void PMacFree(void *ptr, unsigned int size);
 static int PMacIrqInit(void);
@@ -755,7 +755,7 @@
 static int awacs_volume_setter(int volume, int n, int mute, int lshift);
 static void awacs_mksound(unsigned int hz, unsigned int ticks);
 static void awacs_nosound(unsigned long xx);
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 /*** Mid level stuff *********************************************************/
 
@@ -1789,7 +1789,7 @@
 }
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 static ssize_t pmac_ct_law(const u_char *userPtr, size_t userCount,
 			   u_char frame[], ssize_t *frameUsed,
 			   ssize_t frameLeft)
@@ -2171,7 +2171,7 @@
 	return stereo? utotal * 4: utotal * 2;
 }
 
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 
 #ifdef CONFIG_ATARI
@@ -2201,7 +2201,7 @@
 };
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 static TRANS transAwacsNormal = {
 	pmac_ct_law, pmac_ct_law, pmac_ct_s8, pmac_ct_u8,
 	pmac_ct_s16, pmac_ct_u16, pmac_ct_s16, pmac_ct_u16
@@ -2211,7 +2211,7 @@
 	pmac_ctx_law, pmac_ctx_law, pmac_ctx_s8, pmac_ctx_u8,
 	pmac_ctx_s16, pmac_ctx_u16, pmac_ctx_s16, pmac_ctx_u16
 };
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 /*** Low level stuff *********************************************************/
 
@@ -2981,7 +2981,7 @@
 }
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 
 /*
  * PCI PowerMac, with AWACS and DBDMA.
@@ -3609,7 +3609,7 @@
 	while (!req.complete) cuda_poll();
 }
 
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 /*** Machine definitions *****************************************************/
 
@@ -3648,7 +3648,7 @@
 };
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 static MACHINE machPMac = {
 	DMASND_AWACS, PMacAlloc, PMacFree, PMacIrqInit,
 #ifdef MODULE
@@ -3949,7 +3949,7 @@
 		break;
 #endif /* CONFIG_AMIGA */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	case DMASND_AWACS:
 		if (awacs_revision<AWACS_BURGUNDY) { /* Different IOCTLS for burgundy*/
 			switch (cmd) {
@@ -4297,10 +4297,10 @@
 
 static void sq_setup(int numBufs, int bufSize, char **buffers)
 {
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	int i;
 	volatile struct dbdma_cmd *cp;
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 	sq.max_count = numBufs;
 	sq.max_active = numBufs;
@@ -4319,7 +4319,7 @@
 	sq.block_size_half = sq.block_size>>1;
 	sq.block_size_quarter = sq.block_size_half>>1;
 #endif /* CONFIG_AMIGA */
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	cp = awacs_tx_cmds;
 	memset((void *) cp, 0, (numBufs + 1) * sizeof(struct dbdma_cmd));
 	for (i = 0; i < numBufs; ++i, ++cp) {
@@ -4329,7 +4329,7 @@
 	st_le32(&cp->cmd_dep, virt_to_bus(awacs_tx_cmds));
 	out_le32(&awacs_txdma->control, (RUN|PAUSE|FLUSH|WAKE) << 16);
 	out_le32(&awacs_txdma->cmdptr, virt_to_bus(awacs_tx_cmds));
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 }
 
 static void sq_play(void)
@@ -4649,11 +4649,11 @@
 		sound.dsp.speed = 8000;
 		break;
 #endif /* CONFIG_AMIGA */
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	case DMASND_AWACS:
 		sound.dsp.speed = 8000;
 		break;
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 	}
 
 	/* before the first open to /dev/dsp this wouldn't be set */
@@ -4694,11 +4694,11 @@
 		mach = "Amiga ";
 		break;
 #endif /* CONFIG_AMIGA */
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	case DMASND_AWACS:
 		sprintf(mach, "PowerMac (AWACS rev %d) ", awacs_revision);
 		break;
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 	}
 	len += sprintf(buffer+len, "%sDMA sound driver:\n", mach);
 
@@ -4838,7 +4838,7 @@
 void __init dmasound_init(void)
 {
 	int has_sound = 0;
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	struct device_node *np;
 #endif
 
@@ -4872,7 +4872,7 @@
 	}
 #endif /* __mc68000__||CONFIG_APUS */
 
-#ifdef CONFIG_PPC
+#ifdef CONFIG_PMAC
 	awacs_subframe = 0;
 	awacs_revision = 0;
 	np = find_devices("awacs");
@@ -4951,7 +4951,7 @@
 					&awacs_sleep_notifier);
 #endif /* CONFIG_PMAC_PBOOK */
 	}
-#endif /* CONFIG_PPC */
+#endif /* CONFIG_PMAC */
 
 	if (!has_sound)
 		return;
